*                 CORRIGE DE L'EXERCICE CHAPITRE 2 - EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C2EX1 avant d'ouvrir le do.fileC2EX1 qui est fichier programme,

* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer les calculs de l'exercice. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.


* Etape 1 : Calculer la consommation théorique sur les 10 ans. Le programme Stata est le suivant :

gen consotheorique=revenu*0.8+1000

*Donner le tableau de résultat sous forme de matrice:

mkmat revenu consotheorique, mat(Tableau1)
mat list Tableau1

*Etape 2 : Créer un alea gaussien de moyenne 0 et de variance 20000.*Pour un échantillon de 10 observations.
set obs 10

gen u=uniform()
gen alea=invnorm(u)*sqrt(20000)

*Etape 3 : Avec cette nouvelle variable nommée alea calculer la consommation observée

gen consoobservée=0.8*revenu+1000+alea

*Donner un tableau de résultats avec les deux consommations.

mkmat revenu consotheorique alea consoobservée, mat(Tableau2)
mat list Tableau2

* Etape 4 : Donner les caractéristiques de l'alea : moyenne et écart-type.

summarize alea

*Etape 5 : Créer un échantillion de coefficient a chapeau selonune loi normale (150 replications).

program define loinorm, rclass
drop _all
set obs 10
gen e = invnorm(uniform())*sqrt(20000)
gen x = uniform()*16000
gen y = 1000+ 0.8*x + e
regress y x
return scalar b=_coef[_cons]
return scalar a=_coef[x]
end
simulate "loinorm" b=r(b) a=r(a), reps(150)

*Etape 6 : Créer le vecteur colonne des valeurs de a et b chapeau.

gen acha=a
gen bcha=b

*On peut vérifier la moyenne et l'écart-type des coefficients estimés.

summarize acha bcha

* Pour finir on peut faire l'histogramme de a

 histogram acha
