 *                 CORRIGE DE L'EXERCICE CHAPITRE 3 - EXERCICE 1 
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C3EX1 avant d'ouvrir le do.fileC3EX1 qui est fichier programme,
*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile) 
*pour démarrer. Le programme sera exécuté dans son intégralité

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.                   

* On trouvera ici les exercices 1, 2 et 3 du chapitre 3 qui utilise à chaque fois le même fichier C3EX1

                                                        *EXERCICE 1 DU CHAPITRE 3 (Fichier de données C3EX1)
								
*Définir les différentes matrices

*Créer la colonne de la constante qui ne prendra que des 1 et sera intégrée dans la matrice des variables explicatives X (1, x11, x12, X13)

gen b=1

*Créer les vecteurs colonnes de données comme étant des matrices X et Y

mkmat b x1 x2 x3, mat(X)
mkmat y, mat(Y) 

*Présenter la matrice de l'ensemble des données utilisées dans l'exercice.

mkmat y b x1 x2 x3, mat(Tableau1)
mat list Tableau1

* Créer la matrice X'X et(X'X)-1

matrix XX=X'*X
mat list XX
matrix invXX=syminv(XX)
mat list invXX

* Créer la matrice X'Y
matrix XY=X'*Y
mat list XY

*Faire  le calcul final de la matrice des a châpeau, noté ahat (coefficients estimés)

matrix ahat=invXX*XY
mat list ahat

*Créer un vecteur colonne des valeurs de ahat.

svmat double ahat, name(achapeau)
* Calculer l'écart-type estimé de ahat  avec tout d'abord la matrice des résidus

matrix e=Y-X*ahat
mat list e
svmat e

* La variance estimée des résidus

matrix variancee=(e'*e)/(14-3-1)
mat list variancee
svmat variancee
gen ecarttyperésidus=sqrt(variancee)
display ecarttyperésidus

* La diagonale de la matrice des variances et covariances

matrix kk=vecdiag(invXX)
mat list kk

* La matrice des variances et co-variances

matrix vacova=variancee*inv(XX)
mat list vacova

*Les variances estimées de chaque coefficent sont sur la diagonale de la matrice vacova

matrix variancedescoef=vecdiag(vacova)
mat list variancedescoef

*Les écarts-types estimés de chaque coefficients

matrix variancedescoeft= variancedescoef'
mat list variancedescoeft

* La creation d'un vecteur colonne avec les valeurs des variances des coefficients

svmat variancedescoeft
display variancedescoeft

*Créer une colonne pour les ecart-types estimés des coefficients

gen ecarttypedescoef=sqrt(variancedescoeft)

*Faire de la colonne des écartype des coefficients une matrice pour les calculs futurs

mkmat ecarttypedescoef, mat(mecartcoef)
mat list mecartcoef 

*Le calcul du R2, la moyenne de y et la somme des carrés des résidus

egen ybarre=mean(y)
gen ecartyy2=(y-ybarre)^2
egen sumecarty=sum(ecartyy2)
display sumecarty
gen insunecarty=(1/sumecarty)
display insunecarty
mkmat insunecarty
matrix e22=e'*e
mat list e22
matrix r=[insunecarty]*e22
matrix list r

*Pour le calcul du R2 qui pour l'instant à la forme d'un vecteur colonne, il faut créer une matrice unité.

matrix I=(1\1\1\1\1\1\1\1\1\1\1\1\1\1)
matrix R2=I-r
mat list R2

*Faire de R2 un scalaire pour les calculs futurs
svmat R2
display R2
* Calculer le R2 ajusté
matrix R2adj=I-[(14-1)/(14-3-1)]*(I-R2)
svmat  R2adj
display R2adj
               
                                               *EXERCICE 2 DU CHAPITRE 3 (Fichier de données C3EX1) 

* Test sur les coefficients

* Il faut calculer les trois ratios de student et les comparer à la valeur de a table au seuil de 5%. 
* On va utiliser les coefficents (ahat) et leur ecart-type estimé (ecartcoef), stocké dans les matrices ahat et mecartcoef

mat list ahat
mat list mecartcoef 

*Le calcul des 4  t de student correspondant aux 4 coefficients.

gen student =achapeau1/ecarttypedescoef

*Il faut donner les valeurs des quatre t-student . Le premier étant celui de la constante.

mkmat student, mat(student)
mat list student

*Le test d'hypothèse pour les 4 coefficents séparement

gen HO=abs(achapeau1-1)/ecarttypedescoef
mkmat HO, mat(h0)
mat list h0

* Le test d'hypothèse pour deux coefficents simultanément. Estimation de la relation 15 de l'ouvrage avec q=2 paramètres à estimer
* On extrait dans la matrice a chapeau les deux coefficients avec lesquels on fait les tests (coef 1 de la variable x1 et coef 2 de 
* la variable x2)

matrix extrac=ahat[2..3,1]
mat list extrac

*On crée aq

matrix aq=(1\-0.5)
mat list aq

* Calculer la matrice et la transposée de (achapeau -aq) et mutiplier par q=2

matrix Q=(extrac-aq)
mat list Q
matrix Qt=Q'
mat list Qt

*La matrice des variances et covariance a été calculée dans la partie 1 de l'exercice (C3EX1)

mat list vacova

*Nous ne retenons que la sous-matrice de dimension 2*2 correspondant aux deux coefficients de régression du test.

matrix sigmaaq=vacova[2..3,2..3]
mat list sigmaaq

* Calculer l'inverse de la matrice

matrix invsigmaaq=inv(sigmaaq)
mat list invsigmaaq

*Calculer le F avec la formule 

matrix F=(1/2)*Qt*invsigmaaq*Q
mat list F

*Comparer avec le Ft de la table F<Ft. On accepte HO

*Calculer l'intervalle de confiance de la variance de l'erreur à un seuil de 95%. Il est calculé à partir de la formule [16]
* de l'ouvrage.

matrix IC=[(14-3-1)/(20.48)*6.745,(14-3-1)/(3.25)*6.745]
mat list IC

*Le calcul de hi et des résidus standardisés passent par le calcul de la matrice Hat

matrix HAT=X*inv(X'*X)*X'
mat list HAT

*Le levier est sur la première diagonale de la matrice

matrix ht=vecdiag(HAT)
mat list ht

*Transposer la matrice ht pour la récupérer comme un vecteur colonne, puis en faire des scalaires (svmat) pour en faciliter le calcul

matrix h=ht'
mat list h
svmat h

*Calculer les résidus standardisés

gen es=e1*1/[(2.597)*sqrt(1-h)]
mkmat e1 h es, mat(Tableau2)
mat list Tableau2

*Calculer le seuil du levier

gen seuil=2*(3+1)/14
display seuil



****************************EXERCICE 3 DU CHAPITRE  (Fichier de données C3EX1)
*Analyse de la variance

*On applique le test F-Fisher avec trois variables. Attention le R2 est ici noté R21. (Stata code automatiquement différemment une colonne de données
* qui a eut le statut de vecteur colonne (R2) puis de scalaires (R21).

gen F=(R21/3)/(1-R21)*(14-3-1)
display F

*On rejette donc l'hypothése H0. Les coefficients de la relation sont globalement significatifs.

*Le test d'ajout de variable 
*Etape 1, calculer SCT ; SCR, SCE. Certains élements sont déjà calculé dans l'exercice 1 pour  le modème global avec 3 variables.

egen SCT=sum(ecartyy2)
display SCT
egen SCR=sum(e1*e1)
display SCR
gen yestimé=y-e1
egen SCE=sum((yestimé-ybarre)^2)
display SCE

*Etape 2 : Il faut récupérer les grandeurs précédentes dans le cas d'une seul variable explicative. 
* On récupère SCR nommée rss  et SCT nommée mss sous stata que l'on indice par 1. 

regress y x1
gen  SCR1=e(rss)
display SCR1
gen  SCE1=e(mss)
display SCE1

*Calcul de la somme des carrés total du modèle a une variable.

gen SCT1=SCE1+SCR1
display SCT1

*Contruire le tableau d'analyse de la variance (SCR SCR1 SCT SCT1 SCE SCE1) du modèle avec trois variables et avec une variable.

mkmat SCT, mat(SCT)
matrix SCTotal=el(SCT,1,1)
svmat SCTotal
mkmat SCT1, mat(SCT1)
matrix SCTotal1=el(SCT1,1,1)
svmat SCTotal1
mkmat SCE, mat(SCE)
matrix SCExpliqué=el(SCE,1,1)
svmat SCExpliqué
mkmat SCE1, mat(SCE1)
matrix SCExpliqué1=el(SCE1,1,1)
svmat SCExpliqué1
mkmat SCR, mat(SCR)
matrix SCRésidus=el(SCR,1,1)
svmat SCRésidus
mkmat SCR1, mat(SCR1)
matrix SCRésidus1=el(SCR1,1,1)
svmat SCRésidus1

*Récupérer les 6 valeurs dans un tableau nommé sommedescarrées

mkmat SCTotal1 SCTotal11 SCExpliqué1 SCExpliqué11 SCRésidus1 SCRésidus11, mat(sommedescarrées)
matrix sommedescarréest=sommedescarrées'
mat list sommedescarréest

*Calcul du Fisher empirique avec k=3 le nombre de variables explicatives du modèle globale et k'= 1, le nombre 
* de variables du modèle à 1 variable. _N=14 le nombre de variables explicatives.

gen Fisher=[(SCR1-SCR)/(3-1)]/[SCR/(_N-3-1)]
display Fisher

* Etape 3 : Le modèle avec 3 variables est-il stable sous la période ? On fait d'abord les estimations pour la période qui
* va de la 1ere à la 7ème période et on récupére la SCT, SCR, SCE dindicés(m1) pour le modèle 1
regress y x1 x2 x3  in 1/7
gen SCEm1=e(mss)
display SCEm1
gen SCRm1=e(rss)
display SCRm1
gen SCTm1=SCEm1+SCRm1
display SCTm1

 * On fait  les estimations pour la période qui va de la 8ème à la 14ème période et on récupére la SCT, SCR, SCE  indicés(m2) 
 * pour modèle 2
 
regress y x1 x2 x3  in 8/14
gen SCEm2=e(mss)
display SCEm2
gen SCRm2=e(rss)
display SCRm2
gen SCTm2=SCEm2+SCRm2
display SCTm2

* On peut a présent calculer le Fisher avec la formule de l'ouvrage en faisant attention aux ddl.

gen Fisherempirique=(SCR-(SCRm1+SCRm2))/(3+1)/[(SCRm1 +SCRm2)/(6)]
display Fisherempirique
drop Fisherempirique

* Les coefficients sont globalement stables sur l'ensemble de la période puisque le F de la table = 4.53

*Etape 4 : Le test pour a1=1  et a2=a3.
*Si l'hypothèse est vraie le modèle s'écrit z= a0 + a2*v. Il faut donc créer z et t

gen z=y-x1
gen v=x2+x3
mkmat z v, mat(variablestransformées)
mat list variablestransformées

* On récupére SCTzv SCEsv et SCRsv

regress z v
gen SCEzv=e(mss)
display SCEzv
gen SCRzv=e(rss)
display SCRzv
gen SCTsv=SCEzv+SCRzv
display SCRzv

* Le Fisherempirique est donné par

gen Femp=(SCRzv - SCR)/2/[(SCR/10)]
display Femp

* On peut conclure que l'hypothèse H0 est acceptée

