*  CORRIGE DE L'EXERCICE CHAPITRE 3 - EXERCICE 13 
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C3EX13 avant d'ouvrir le do.fileC3EX13 qui est fichier programme.

*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run *(Execute en haut à droite de la barre de menu du dofile) pour démarrer *             

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats. *
                                * CHAPITRE 3 EXERCICE 13
			*Estimation d'une fonction de production : impact de la privatisation 
			
* Comme nous avons une fonction Cobb-Douglas (multiplicative), pour appliquer les MCO il  faut linéariser la relation en la passant en LOG. 
* On se retrouve alors avec une fonction additive.

*Etape 1 : On crée les variables en log et les variables interactives
gen LQ=log(q)
gen Llabor=log(l)
gen Lkapital=log(k)
gen dumLL=dum*Llabor
gen dumLK=dum*Lkapital

* On fait la régression avec la variable muette dum et les interactive dum*Labor (dumLL) et  dum*capital (dumLK)

regress LQ Llabor Lkapital dum dumLL dumLK

* Les variables Llabor, dumLL et dumLK ne sont pas significatves. On peut donc les retirer du modèle une par une

* Dans un premier temps on supprime dumLK et on refait l'estimation

regress LQ Llabor Lkapital dum dumLL

* A présent les variables sont toutes significatives. Y compris la variable dum. Il y a une différence significative entre 
*les entreprises du secteur public (dum=0) et celle du secteur privé (dum=1).

* Etape 2 : Il est possible de procéder au test de Chow
* Il faut d'abord faire la régression du modèle avec l'échantillon complet (le modèle non contran=int)
* avec _N=50 observations et k=2 variables explicatives. Il faut ensuite récupérer la SCR du modèle global (nommée rss sous stata).

 regress LQ Llabor Lkapital
 scalar scr=e(rss)
 display scr
 
*Il faut ensuite faire la régression juste pour les entreprises publiques dum==0 et récupérer la SCR1

regress LQ Llabor Lkapital if dum==0
scalar scr1=e(rss)
display scr1
 
*Il faut ensuite faire la régression juste pour les entreprises privées dum==2 et récupérer la SCR2

regress LQ Llabor Lkapital if dum==1
scalar scr2=e(rss)
display scr2

* On peut à présent calculer la statistique de Fisher.

scalar F=[(scr-(scr1+scr2))/3]/((scr1+scr2)/(50-2*3))
display F

* Comme F=4.42 supérieur au F de la table qui est égal à 2,84 nous rejetons HO. Le modèle est instable.

* Etape 3 : Les résultats de la  fonction tranlog sont obtenus après création des nouvelles variables nécessaires à l'estimation.

gen O5Logk=0.5*log(k)^2
gen O5LogL=0.5*log(l)^2
gen LogkLogl=log(k)*log(l)

* La régression est ensuite réalisée.

regress LQ Lkapital Llabor O5Logk O5LogL LogkLogl

* Le Wald test est obtenu sous stata à partir de la syntaxe suivante :

test _b[O5Logk]=_b[O5LogL]=_b[LogkLogl]==0

* La probabilité critique du test est de 75% nous acceptons donc HO. Translog n'est pas mieux adaptée que la spécification Cobb-Douglas.
