*  CORRIGE DE L'EXERCICE CHAPITRE 3 - EXERCICE 7 
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données C3EX7 (format Stata) avant d'ouvrir le do.fileC3EX7 qui est fichier programme. 
* Attention c'est bien le fichier de l'exercice 1 que l'on réutilise pour l'exercice 7.

*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer *   
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats. 
          

                                *EXERCICE 7 DU CHAPITRE 3 
* Prévision à partir d'un modèle linéaire.

* Question 1 : Il faut estimer le modèle à deux variables explicatives
regress y x1 x2

*On peut dès lors récupérer la valeurs des coefficients estimés.

gen const=_b[_cons]
gen a1=_b[x1]
gen a2=_b[x2]

* Il faut calculer les variables estimées de y pour la 15ème et 16ème période à partir des valeurs de x115=3 et x116=6, 
* puis x215=24 et x216=38 (attention a2 est déjà un coefficient stocké en négatif par le logiciel )

gen y15=const+a1*3+a2*24
gen y16=const+a1*6+a2*38

* Afin de réaliser le calcul de la matrice X'X, il faut tout d'abord créer la colonne de la constante.

gen b=1

* Il faut ensuite créer la matrice X et calculer X'X-1.

mkmat b x1 x2, mat(X)
matrix XX=(X'*X)
mat list XX
matrix invXX=inv(XX)
mat list invXX

* Il faut ensuite créer le vecteur colonne.
* X15 et son transposé X15t

matrix X15=[1\3\24]
mat list X15
matrix X15t=X15'
mat list X15t

* Il faut récupérer la valeur de la variance estimées des résidus du modèle (noté rmse dans Stata)

scalar rmse=e(rmse)
display rmse

* oOn peut donc calculer la variance et l'écart type de l'erreur de prévision à partir de la formule proposée dans l'ouvrage.

matrix variancex15=[(rmse)^2]*[X15t*invXX*X15 + 1]
mat list variancex15
svmat variancex15
gen ecarttypeX15=sqrt(variancex15)
display ecarttypeX15

* Il suffit de procéder de la même manière pour X16.

* On peut à présent calculer l'intervalle de prévision pour y15, avec une fourchette basse (FB) et une fourchette haute (FH)
* et un t de student (n-k-1 ddl) = 2,201

gen y15FB=y15-2.201*ecarttypeX15
display y15FB
gen y15FH=y15+2.201*ecarttypeX15
display y15FH
