*CORRIGE DE L'EXERCICE CHAPITRE 5 - EXERCICE 3
*Dalila Chenaf-Nicet  Université de Bordeaux.
 
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C5EX3 avant d'ouvrir le do.fileC5EX2 qui est fichier programme. 
 
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer.
 
  
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

      
*                               CHAPITRE 5 EXERCICE3 
 * Correction de l'hétéroscedasticité lorsque les données représentent des moyennes


* Tout d'abord créer la variable groupe (ici on aurait pu utiliser une boucle itérative mais étant donnés le peu de ligne à modifier 
* le programme ci-après est aussi rapide)
gen groupe = 1
replace groupe = 2 in 2
replace groupe = 3 in 3
replace groupe = 4 in 4
replace groupe = 5 in 5

* Dans la mesure où il faut utiliser les MCG il faut tout d'abord définir la matrice diagonale notée l'inverse de V (inV)
mkmat n, mat(Ni)
matlist Ni
matrix inV=(12,0,0,0,0\0,8,0,0,0\0,0,6,0,0\0,0,0,9,0\0,0,0,0,5)
matlist inV

 * Il faut aussi créer chacune des colonnes de données comme des vecteurs matriciels pour faciliter les calculs
 mkmat x, mat(X)
 mkmat y, mat(Y)
 
* Il faut estimer la relation qui va lier y et x, mais les données sont des données moyennes, il faut donc calculer un certain nombre
* de grandeurs : n*ybar, n*xbar, n*ybar au carré et n*xbar au carré aini que  n*ybar*xbar, que l'on stocke dans le tableau 4 (sous 
* forme de matrice):

gen nybar=n*y
gen nxbar=n*x
gen nxbar2=n*x^2
gen nybar2=n*y^2
gen nybarxbar=n*y*x

mkmat n nybar nxbar nxbar2 nybar2 nybarxbar, mat(tableau4)
matlist(tableau4)

* Il faut faire la somme des colonnes pour obtenir les éléments de calcul des matrices notées :
* A= (X'V-1X) et (X'V-1 X)-1=A-1  et B=(X'V-1 Y) et (X'V-1 Y)-1 = B-1
egen N=sum(n)
display N

egen NXbar=sum(nxbar)
display NXbar

egen NYbar=sum(nybar)
display NYbar

egen NXbar2=sum (nxbar2)
display NXbar2

egen NYX=sum(nybarxbar)
display NYX

mkmat N NXbar NXbar2 NYbar NYX, mat(somme)
matlist somme

* Contruire les matrices A et B à l'aide des différentes grandeurs qui viennent d'être calculées :
matrix N1=somme[1,1]
matlist N1
matrix NXbar1=somme[1,2]
matlist NXbar1
matrix NXbar21=somme[1,3]
matlist NXbar21
matrix NYbar1=somme[1,4]
matlist NYbar1
matrix NYX1=somme[1,5]
matlist NYX1
matrix A=(N1, NXbar1\ NXbar1,NXbar21)
matlist A
matrix B=(NYbar1\NYX1)
matlist B

* Calculer l'inverse de la matrice A
matrix invA=inv(A)
matlist invA

* Calculer la matrice des coefficients selon la formule du livre.
matrix ahat=invA*B
matlist ahat

* Avec la matrice ahat on peut calculer Y-Xa=zz

gen Xa=-1.23+0.502*x
gen zz=y-Xa

mkmat zz, mat(yXa)
matlist yXa

* Il fait a présent estimer la variance de l'erreur notée sigma2 à partir des différents éléments déja calculés

matrix yXat=yXa' 

matrix sigma2 =(1/3)*(yXat*inV*yXa)
matlist sigma2

*La matrice des  variances et covariances est donnée par : 

matrix varcov=sigma2*invA
matlist varcov

* On obtient ainsi 0,094 qui est la valeur de la variance estimée de la constante et 0,0025  qui est la variance estimée
* du coefficient a chapeau

* Le calcul du t de student est alors donné par la valeur du a chapeau (0,502) et son écart type (la racine de 0,0025) 

gen t=0.502/(0.0025)^(1/2)
display t

* t calculé est supérieur au t de la table (3,18) nous rejetons l'hypothèse H0
