*CORRIGE DE L'EXERCICE CHAPITRE 5 - EXERCICE 4 
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C5EX4 avant d'ouvrir le do.fileC5EX4 qui est fichier programme.
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile) 
* pour démarrer 

 
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

      
*         CHAPITRE 5 EXERCICE 4
*Test de détection de l'hétéroscedasticité

* Il faut tout d'abord définir les 6 groupes
egen m=group(x)

* Comme les données sont constituées pour m=6 groupes d'observations il faut calculer la variance empirique pour chacun groupe (i=1,..6)

gsort -m
bysort m: egen sdi=sd(y)
bysort m : gen vari=sd^2

* On peut faire un tableau noté V avec les 6 variances de chaque groupe
mkmat vari, mat(variancei)
matlist variancei

matrix var1=variancei[1,1]
matrix var6=variancei[6,1]
matrix var11=variancei[11,1]
matrix var16=variancei[16,1]
matrix var21=variancei[21,1]
matrix var26=variancei[26,1]

matrix V=[var1\var6\var11\var16\var21\var26]
matlist V

* Calculer la variance totale à partir de la matrice V qui comporte les 6 variances des groupes à partir de la 
*formule de l'ouvrage (en décomposant le numérateur "num" du dénominateur "den")

svmat V, names(V)
gen num=(4*V1)
egen variancet=sum(num)
gen den=(24)
gen variancetotale =variancet/den
display variancetotale

** Les étapes du calcul du khi2

*vi= ni-1 = 4 et la somme des vi= m*(ni-1) = 24 =den

* la quantité à calculer selon la formule de l'ouvrage nécessite de calculer logvariance totale et des 6 variances par groupe 
gen vlnvarT=den*log(variancetotale)
gen vlnvari=4*log(V1)
egen sommevlnvari=sum(vlnvari)

* Le calcul de  Qprime
gen Qprime=vlnvarT-sommevlnvari
display Qprime

* Pour affiner le calcul on peut calculer la grandeur C pour Q avec Q=Qprime/C
gen C=1 +[1/(3*(6-1))]*[6*(1/4)-(1/4)]
display C

gen Q=Qprime/C
display Q

* Q est supérieur à 11,07 lu sur la table pour un risque de 1ere espéce de 5% et 6ddl. Le modèle est donc hétéroscedastique

**************************** On peut aussi faire le test de Golgfeld-Quandt

* Etape 1 : il faut ordonner les observations en fonction des variables croissantes ou décroissante de la variable à expliquer y. 
* Or elles sont déjà classées par ordre croissant
* On choisit D observations situées au centre de l'échantillon en règle générale  D= _N/4. En prenant la partie entière de la division.

gen D=_N/4
display D

* On choisit donc D=8. On exlut donc les 8 valeurs centrales de la série des observations
* On conserve donc deux échantillons le premier de la 1er à la 11ème observations et le deuxième de la 20ème à la 30ème


* Faire les régressions pour les deux échantillons et récupérer les résidus
regress y x in 1/11
gen rss1=e(rss)
display rss1

regress y x in 20/30
gen rss2=e(rss)
display rss2

* Calculer le F avec ddl =n-2=11_2=9
gen F=(rss1/9)/(rss2/9)
display F

 * F est supérieur à 3.18 lu sur la table pour un risque de 1ere espéce de 5% et (9,9)ddl. Le modèle est donc hétéroscedastique

* *******************************On peut faire le Test de Gleisjer

* Etape 1: on régresse le modèle complet et on récupére le vecteur des résidus
regress y x
 predict ei, re

 * On régresse ensuite la valeur absolue des résidus par rapport à X
 
 gen absei=abs(ei)
 regress absei x
 
 * On régresse ensuite la valeur absolue des résidus par rapport à X2
 gen x2=sqrt(x)
 regress absei x2
 
 * Les t-students empiriques des deux relations indiquent que les coefficients sont significativement différentes de zéro. 
 * L'hétéroscedasticité est détectée.
 
 ************************************ On peut faire le Test de White
 
 * Il est fondé sur une relation significative entre le carré des résidus de la régression y/ x et les x au carré
 * Ici nous n'avons qu'une seule variable explicative. on pourra recourir à la statistique LM distribuée comme un Khi2 ou F.
 
 regress y x
 predict re, re
 gen re2=re^2
 
 * Soit ici le modèle testé 
 regress re2 x x2
  gen R2=e(r2)
  display R2
  
  gen LM=_N*R2
  display LM
  
 *La valeur de LM calculée est supérieur au khi2 de la table (5.99) pour un risque de 1ere espece de 6 % et p=2*k ddl
 *L'hétéroscedasticité est détectée
 
 ******************************* Correction de l'hétéroscédasticité
 * On crée un variable Z=(Y/sqrt(X)) , X1=1/(sqrt(X)) et  X2=X/(sqrt(X))
 
 gen Z=y/sqrt(x)
 gen  X1=1/sqrt(x) 
 gen X2=x/sqrt(x)
 
 * On réalise la régression de ces variables
 regress Z X1 X2, noconstant

 * Le modèle estimé est donc Y= 24,96 - 4.53 *X +e
 
 * Il existe bien une influence significative du temps de vérification sur le nombre de défauts constatés. 
 * Chaque heure de vérification permet de supprimer en moyenne 4,5 défauts
