 *CORRIGE DE L'EXERCICE CHAPITRE 5 - EXERCICE 6
*Dalila Chenaf-Nicet  Université de Bordeaux.
  
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C5EX6 avant d'ouvrir le do.fileC5EX6 qui est fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer 
 
  
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

 *                                    CHAPITRE 5 EXERCICE 6 
                                    * Prévision de part de marché
  
  
 * Dans un premier temps il s'agit de faire la régression de pm (part de marché) par rapport à dn (l'univers de vente). 
 * Mais les données sont en log dans le modèle. Il donc faut créer les variables en log
 
gen logpm=log(pm)
gen logdn=log(dn)

* Puis faire la régression avec les nouvelles variables
regress logpm logdn

* Le coefficient a1 = 1.029 représente une élasticité car le modèle est sous la forme log-log.
* Si on observe le t de student de a1 (t=6.83), le coefficient est significativement différent de 0 car le t est largement supérieur
* au t de la table =1.96

* Il s'agit de récupérer dans un deuxième temps les résidus de la relation

predict  residu, re

* Il faut ensuite faire le graphe des résidus, en précisant que semaine est notre variable du temps
tsset semaine
twoway(tsline residu)

* Le graphique laisse supposer une autocorrélation des erreurs. Il faut faire ici le test de Durbin watson. 
* stata indique directement le test avec la commande suivante qui donne la fois les résultats de la régression et la statistique
regdw logpm logdn

* Dw = 1.29 <1.44 (valeur de la tabble). Il existe une présomption d'autocorrélation des erreurs d'ordre 1.

* Il s'agit d'introduire une nouvelle variable dans l'analyse qui est IP, l'indice des prix

gen logip=log(ip)
regdw logpm logdn logip

*  Concernant les résultats on peut faire les commentaires suivant:
*                 - La statitique de Fisher F=61.38 indique que le modèle est globalement significatif.
*                 - La statistique de DW = 1.828 ne laisse plus présager d'autocorrélation. 
* Le modèle est donc valide sur le plan statistique.

* Connaissant pour la semaine 42 les nouvelles valeurs de dn=0.60 et ip=100, il est demandé de calculer la nouvelle valeur de pm.

*On doit d'abord calculer les données en log
gen logdn42=log(0.60)
gen logip42=log(100)

* On peut avec les coefficients estimés calculer la nouvelle valeur de logpm42
gen logpm42 = 1.285*logdn42 - 4.716*logip42 + 25.221
display logpm42

* Il faut calculer l'exponentielle de cette valeur pour obtenir la grandeur réelle de pm42
 gen pm42=exp(logpm42)
 display  pm42

 * La part de marché prévue est de 17,2%.
 
* Il faut calculer l'écart type de prévision. Il faut constuire (inv(X'X))= Z 

gen b=1
mkmat b logdn logip, mat(X)

matrix Z=(inv(X'*X))
mat list Z

* Il faut calculer la variance estimée des résidus de la régression avec les deux variables explicatives 
regress logpm logdn logip
predict résidu2,re

egen zz=sum(résidu2^2)

gen sigma2=zz/(_N-2-1)
display sigma2

* IL faut calculerd X't+h * (inv(X'X)*Xt+h en définisant au préalable xt+h avec les données de l'exercice

matrix Xth=(1\-0.51\4.605)
matlist Xth
matrix uu= Xth'*(Z)*Xth
matlist uu
svmat uu
gen sigma2th=sigma2*(1+uu)
display sigma2th

 * Les bornes de l'intervalle de prévision sont données par 2.84(+-)*1.96*sqrt(0.033)
 
 gen bornebasse= 2.84-1.96*(sqrt(sigma2th))
 display bornebasse
  gen bornehaute= 2.84+1.96*(sqrt(sigma2th))
 display bornehaute
