 *CORRIGE DE L'EXERCICE CHAPITRE 6 - EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.


* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C6EX1 avant d'ouvrir le do.fileC6EX1 qui est fichier programme. 
   
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
*  pour démarrer 

 
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
      
*                                          CHAPITRE 6 EXERCICE 1 
*                                          Estimation des paramètres d'une fonction de type CES
   

* Il faut daans un premier temps passer en log les variables de la fonction afin d'avoir une forme linéaire à estimer. 
* Les coefficients estimés seront alors considérés comme des élasticités

gen logk=log(k)
gen logl=log(l)
gen logq=log(q)
  
* On définira une variable du temps pour calculer le DW lors des estimations. Mais attention le  DW ne doit pas s'interpreter car les
* données sont en coupe et le temps est introduit artificiellement  pour forcer le logiciel à donner des statistiques.
  
gen temps=[_n]
tsset temps

 * On peut à présent la régression et obtenir en plus des statistiques usuelles le DW
 regdw logq logk logl

 
 *L'estimation statistique est satisfaisante puisque l'élasticité de la production au capital est = 0.64: si le capital augmente de 10% 
 * la production augmente de 6.4%
 * L'élasticité de la production au travail est = 0.25 et aussi significative  si le travail augmente de 10%, la production augmente 
 * de 2.5%
 
* Le calcul du coefficient de la constante.
* Tout d'abord récupérer la valeur de la constante sous forme de scalaire

 scalar coefa0=_b[_cons]
 display coefa0
 
 * Faire le calcul en base 10
  gen alph0=10^(coefa0)
 display alph0

 * La fonction de production estimée est donc Q=302.7*K.0.64*L.0.25 (les données numériques sont  à considérer comme étant "a la puissance").
 
 * Il faut à présent travailler sur les rendements d'échelle. La question qui se pose est : sont - ils constants ?
 * (la somme des coefficients est égale à 1). Sont-ils croissants (la somme des coefficients est supérieure à 1) ou décroissants 
 * (la somme des coefficients est inférieure à 1?
 
 * On sait que alpha1= 0.64 et alpha2= 0.25. La somme alpha1+alpha2 est - elle significativement égale à 1 ou inférieure à 1 est finalement
 * la question du test.
 
 *Le test revient à tester le t-student = (alpha1estimé+alpha2estimé -1)/(la variancce estimée des coefficients)
 
* Le numérateur de l'expression du t est donc donnée par : 
 scalar alpha1=_b[logl]
display alpha1
 scalar alpha2=_b[logk]
display alpha2
gen num= (alpha1+alpha2-1)
display num 

 *La matrice des variances covariances est donnée par :
  matrix x = e(V)


* on peut donc récupérer les variances estimées des coeffcients dans la diagonale de X afin de récupérer les éléments 
* du dénominateur (den) de l'experssion de t-student. Il nous faut aussi les écarts-type et la covariance 
  
matrix sigmaK=x[1,1]
matlist sigmaK
svmat sigmaK
  
matrix sigmaL=x[2,2]
matlist sigmaL
svmat sigmaL
   
matrix cov=x[2,1]
matlist cov
svmat cov
gen den=(sigmaL1+sigmaK1 + 2*cov1)
display den

* Le calcul du t est alors donné par :
gen t = num/sqrt(den)
display t
  
* Nous avons donc 2% de risque de rejeter H0 à tort, les rendements d'échelle sont significativement décroissants.
