*CORRIGE DE L'EXERCICE CHAPITRE 8- EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C8EX1 avant d'ouvrir le do.fileC8EX1 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile).
* pour démarrer le programme. Il sera exécuté dans son intégralité.

* Il est possible en sélectionnant les étapes du programme de l'exécuter pas à pas.
  
 
 *                                          CHAPITRE 8 EXERCICE 1
 *                          Comparaison des résultats par MCO, MCI et DMC
 
 * 1 - Les conditions d'identifiabilité du modèle
 
 * la première équation E1 qui va lier Y1 à Y2 et X1 a une restriction de contrainte et une restriction 
 *d'exclusion (Y2 et X1 ont des coefficients égaux).
 
 *Si on applique les conditions d'identification on a E1
 * g'= le nombre d'endogènes dans l'équation = 2
 * k' = le nombre de variables exogènes dans l'équation = 1
 * r = 1 nous n'avons qu'une seule restriction si on exclu la restriction d'exclusion
 * g= le nombre endogènes du modèle = 2
 * k = le nombre de variables exogènes du modèle = 2
 * Soit pour E1  = 2-2+2-1+1= 2> g-1=2-1=1  l'équation est sur-identifiée

 *Si on applique les conditions d'identification on à E2
 * g'= le nombre d'endogènes dans l'équation = 2
 * k' = le nombre de variable exogène dans l'équation = 1
 * r = 0 nous n'avons aucune restriction 
 * g= le nombre endogènes du modèle = 2
 * k = le nombre de variables exogènes du modèle = 2
 * Soit pour E1  = 2-2+2-1+0= 1> g-1=2-1=1  l'équation est juste identifiée
 
 * Nous pouvons donc identifier les coefficients du modèle
 
 * 2 - L'estimation par les MCO pour E1

 * Il faut créer la variable y2+x1
 
 gen y2x1 = y2+x1

* Faire la régression sans la constante
 regress y1 y2x1, noconstant
 gen  a=_b[y2x1]
 display a
 
 * L'estimation par les MCO pour E2 est donnée par
 
 regress y2 y1 y11, noconstant
gen  b=_b[y1]
 
 * Le problème est que pour ces estimations, l'estimateur n'est pas BLUE en raison de la non indépendance entre variables explicatives 
 * et l'aléa.
 
 ************************ On applique alors la méthode des moindres carrés indirects. Il faut mettre le modèle sous sa forme réduite
 * y1 = a1*x1 + b1 y11 +et pour E1 et y2= a'x1 + b' y11
 
 regress y1 x1 y11, noconstant
scalar a1=_b[x1]
display a1
gen b1=_b[y11]
display b1
   
 regress y2 x1 y11, noconstant
scalar c=_b[x1]
display c
scalar e=_b[y11]
display e

* En utilisant la valeur des coefficients on en déduit bhat=0,495 et chat = 0.045
   
****************************** Le calcul des DMC
   
* Le calcul par étape
   
 * Etape 1 : estimer y2
    regress y2 x1 y11
	
	*étape 2 calculer la valeur de y2 estimé
	gen y2hat=_b[x1]*x1+_b[y11]*y11
   
   * Etape 3 utiliser y2 estimé dans l'équation E1
   gen y2hax1= y2hat+x1
   
   regress y1 y2hax1
   gen  admc=_b[y2hax1]
   display admc
   
* Mais on peut directement utiliser les DMC avec le programme ivregress de Stata .
   
* Le codage est le suivant : On précise l variable expliquée y2 suivie de sa variable exogène y11, la variable endogène que l'on souhaite
* instrumenter et par quelle variable 
   
   ivregress 2sls y2  y11 (y1=x1)
   gen bdmc=_b[y1]
   display bdmc
   
* La synthèse des résultats:  Il s'agit de construire les tableaux de résultats sous forme de matrices de résultats.
mkmat a b , mat(mco)
matrix MCO=mco[1..1,1..2]

mkmat admc bdmc, mat(dmc)
matrix DMC=dmc[1..1,1..2]

matlist MCO
matlist DMC

*A la lecture de ces résultats nous constatons des différences assez faibles entre les estimations  MCO et DMC

