*CORRIGE DE L'EXERCICE CHAPITRE 9 - EXERCICE 3
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C9EX3 avant d'ouvrir le do.fileC9EX3 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile)
*pour démarrer le programme. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
 
                                * CHAPITRE 9 EXERCICE 3
                   * Analyse par la méthode BJ et prévision

* Tout d'abord il faut faire le graphe de la relation
tsset tendance
twoway (tsline x1)

* Puis il faut faire le corrélogramme : 
corrgram x1, lag(20)
ac x1, lag(20)
pac x1, lag(20)

* A la lecture du corrélogramme (décroissance lente de AC) le processus n'est pas stationnaire.

* On démarre une stratégie simplifiée de test : Modèle 3 Phililips-Perron (trend et constant)
 pperron x1, lag(4) trend regress
 
* Dans la mesure où (pp-stat=-2,148 > -3.343 (5%). On accepte l'hypothèse de racine unitaire. 
* Dès lors pour savoir si le coefficient de la tendance est significatif on ne peut plus utiliser student. 
* Il faut utiliser la table fournie dans l'ouvrage (Table 7 : DF)
* Pour le coefficient du trend on obtient t=1.86 <3.12 (5%) : le trend n'est pas significatif (il ne l'est pas  même à 10%).
* Il faut donc estimer le modèle 2
 
* Le modèle avec constante mais sans trend
  pperron x1, lag(4) regress
  
* Dans la mesure où (pp-stat=0.30 > -3.343 (5%). On accepte l'hypothèse de racine unitaire.
* Dès lors savoir si le coefficient de la dérive est significatif on ne peut plus utiliser student.
* Il faut utiliser la table fournie dans l'ouvrage (Table 7 : DF)
 
* Pour le coefficient de la dérive on obtient t=4.17 >2.84 (5%) : La dérive est significative
* Nous avons un processus non stationnaire avec dérive. Nous n'avons pas repéré de trend c'est donc un processus DS
  
* Pour rendre la série stationnaire nous pouvons la passer en différence première (D.x1)
 
* le corrélogramme de D.x1 est donné par :
  
  corrgram D.x1, lag(15)
  
* Il ne s'agit pas d'une marche au hasard, la Q stat nous indique que c'est bien un processus à mémoire il a donc une représentation 
* ARMA possible.
* Recherche des ordre q et p du arma. Ici on est dans une procédure à tâtons où le corrélagramme indique que l'on peut tenter ARMA(1,1), 
* ARMA (2,1). Les critères AIC étant les plus faibles pour ARMA(2,1).

* On tente alors cette représentation (sur la variable en différence première)
  
  arima D.x1,ar(1/2) ma(1) 
  
* La constante est bien significative comme les autres coefficients. Nous allons à présent validé la représentation
  
* Nous récupérons les résidus de la représentation
  predict résidu, re
  corrgram résidu, lag(15)
  
* Le corrélogramme du résidu indique que c'est bien un processus sans mémoire
 
* Il s'agit de faire le test ARCH (résidu au carré). On créer tout d'abord les résidus au carré.
* Puis on fait le corrélogramme
  
gen résiducarré=(résidu)^2
corrgram résiducarré, lag(15)
   
* Aucun terme n'est significatif. Les résidus sont homocedastiques
   
* On doit faire le teste Jarque - Bera
   jb résidu
   
* La statistique jB=1.906 affiche une probabilité critique de 0.38. Les résidus sont normaux.
   
* Comme il a suffit de différencier une fois x1 pour rendre le processus stationnaire nous validons un processus ARIMA (2,1,1)
   
   *////// L'analyse du processus x2
   
* Tout d'abord il faut faire le graphe de la relation

twoway (tsline x2)

* Faire le corrélogramme
corrgram x2, lag(20)
ac x2, lag(20)
pac x2, lag(20)

* A la lecture du corrélogramme (décroissance lente de AC) le processus n'est pas stationnaire et on observe une forte autocorrélation
* à l'ordre 1

* On démarre une stratégie de test Dickey fuller (trend et constant)
* La question qui se pose est : doit-on utiliser DF ou ADF ? Tout dépend de la longueur des retards. 
* si p=0 on peut utiliser DF sinon on utilise ADF

* On va tester différents retards en partant de 3 retards dans le cadre du modèle avec constante (modèle 2)
* A chaque fois on relèvera la valeur des critères d'information. On minimisera les critères

regress x2 L.x2 L2.x2 L3.x3 
estat ic

regress x2 L.x2 L2.x2 
estat ic

regress x2 L.x2 
estat ic

* Les critères pointent 3 retards. Nous démarrons un ADF dans le cadre d'un modèle 3

dfuller x2, lag(3) trend regress

* Nous acceptons l'hypothèse  de racine unitaire. Il faut donc analyser la significativité du trend
* Ici nous avons t du trend t=0,64 <3.12, le coefficient de la tendance n'est pas significatif.
* Nous estimons le modèle 2

dfuller x2, lag(3) regress
* Il faut donc analyser la significativité du de la constante.
* Ici nous avons t de la constannte t=2.36 <2.84, le coefficient de la tendance n'est pas significatif.
* C'est un processus DS sans dérive.

* Il faut passer en différence première x2 et faire le corrélogramme

corrgram D.x2, lag(15)

* C'est un processus à mémoire (ce n'est pas une marche au hasard), les probabilités critiques Q sont tous largement
*inférieurs à 0.05

* Recherche de la représentation.
* Etant donné le corrélogramme nous tentons un ARMA(1,1) mais sans constante
  
  arima D.x2,ar(1) ma(1) noconstant
  
* Nous validons la représentation en faisant les tests sur les résidus
  predict résidu2, re
  
  corrgram résidu2, lag(15)
    
* Il s'agit de faire le test ARCH (résidu au carré). On crée tout d'abord la variable des résidus au carré.
* Puis on fait le corrélogramme
  
  gen résiducarré2=(résidu2)^2
   corrgram résiducarré2, lag(15)
   
* Aucun terme n'est significatif. Les résidus sont homocedastiques
   
* On doit faire le teste Jarque - Bera
   jb résidu2

 * La statistique jB=4.46 affiche une probabilité critique de 0.O6. Les résidus sont normaux (de justesse).
   
* Comme il a suffit de différencier une fois x2 pour rendre le processus stationnaire nous validons un processus ARIMA (1,1,1)
   

      
   *////// L'analyse du processus x3
   
 * Tout d'abord faire le graphe de la relation

twoway (tsline x3)

* Faire le corrélogramme
corrgram x3, lag(20)
ac x3, lag(20)
pac x3, lag(20)

* A la lecture du corrélogramme (décroissance lente de AC)  et une forte autocorrélation partielle à l'ordre 1.
* Le processus n'est pas stationnaire et le graphe laisse à penser la présence d'un trend haussier.

* On démarre une stratégie simplifié de test : Modèle 3 Phililips_Perron (trend et constant)
 pperron x3, lag(4) trend regress
 
 * Dans la mesure où il n'y a une racine unitaire (pp-stat=-15.03 <-3.343 (5%). On rejette l'hypothèse de
 *racine unitaire. Donc on peut utiliser directement la table de student pour analyser le coefficient du trend
 * Avec la table DF est pour le coefficient du trend on obtient t=15,03 >1.96 (5%) : le coefficient du trend est  significatif.
 
* Nous avons un processus TS. Il faut estimer la tendance pour ensuite l'éliminer

regress x3 tendance

* Les coefficients sont tous significativement différents de 0.

predict résidu3, re
corrgram résidu3, lag(15)

gen residucarré=résidu3^2
corrgram residucarré, lag(15)

* Les résidus sont homocedastiques 

jb résidu3

* une probabilité de 0.53, nous acceptons la normalité des résidus. C'est un processus TS

* Si on supprime la tendance le processus est stationnaire
gen y1t=x3-2.996632*tendance
twoway (tsline y1t)
corrgram y1t

dfuller y1t, trend regress
